-- ATTENTION
-- Ce script doit être exécuter sur 1 User qui a le rôle de DBA (ex.: User GRHUM)
-- USER SQL


--
-- Patch DBA de SCO_SCOLARITE du 16/07/2013 à exécuter depuis le user GRHUM
--
-- Rem : fichier encodé UTF-8

SET DEFINE OFF;
--
--
-- Fichier : 2/3
-- Type : DDL
-- Schema : SCO_SCOLARITE
-- Numero de version : 0.1.0.10
-- Date de publication : 16/07/2013
-- Auteur(s) : Association Cocktail
--
--
WHENEVER SQLERROR EXIT SQL.SQLCODE;

-- TABLE GD_STRATEGIE_DEF_PERIMETRE
declare
  is_table_exists int;
  is_constraint_exists int;
  is_sequence_exists int;
begin   
  select count(*) into is_table_exists from all_tables where owner = 'SCO_SCOLARITE' and table_name = 'GD_STRATEGIE_DEF_PERIMETRE';
  if (is_table_exists = 1) then
  	EXECUTE IMMEDIATE('DROP TABLE SCO_SCOLARITE.GD_STRATEGIE_DEF_PERIMETRE CASCADE CONSTRAINTS');
  end if;
  
  select count(*) into is_sequence_exists from all_sequences where sequence_owner = 'SCO_SCOLARITE' and sequence_name = 'GD_STRATEGIE_DEF_PERIMETRE_SEQ';
  if (is_sequence_exists = 1) then
  	EXECUTE IMMEDIATE('DROP SEQUENCE SCO_SCOLARITE.GD_STRATEGIE_DEF_PERIMETRE_SEQ');
  end if;
  
end;
/

CREATE TABLE SCO_SCOLARITE.GD_STRATEGIE_DEF_PERIMETRE (
	ID_GD_STRATEGIE_DEF_PERIMETRE NUMBER(38) NOT NULL,
	CODE VARCHAR2(255),
	LIBELLE VARCHAR2(255),
  	CONSTRAINT PK_GD_STRATEGIE_DEF_PERIMETRE PRIMARY KEY (ID_GD_STRATEGIE_DEF_PERIMETRE) USING INDEX TABLESPACE INDX_CKTL_SCOL
);
CREATE SEQUENCE SCO_SCOLARITE.GD_STRATEGIE_DEF_PERIMETRE_SEQ START WITH 1 NOCACHE;
COMMENT ON TABLE SCO_SCOLARITE.GD_STRATEGIE_DEF_PERIMETRE IS 'Table des types de stratégies pour la définition des périmètres de données';
COMMENT ON COLUMN SCO_SCOLARITE.GD_STRATEGIE_DEF_PERIMETRE.CODE IS 'Code du type de stratégie';
COMMENT ON COLUMN SCO_SCOLARITE.GD_STRATEGIE_DEF_PERIMETRE.LIBELLE IS 'Libellé du type de stratégie';


-- TABLE GD_PERIMETRE_GIROFLE
declare
  is_table_exists int;
  is_seq_exists int;
begin   
  select count(*) into is_table_exists from all_tables where owner = 'SCO_SCOLARITE' and table_name = 'GD_PERIMETRE_GIROFLE';
  if (is_table_exists = 1) then
    EXECUTE IMMEDIATE('DROP TABLE SCO_SCOLARITE.GD_PERIMETRE_GIROFLE CASCADE CONSTRAINTS');
  end if;
end;
/

CREATE TABLE SCO_SCOLARITE.GD_PERIMETRE_GIROFLE (
	ID_GD_PERIMETRE_GIROFLE NUMBER(38) NOT NULL,
	STRATEGIE_ID NUMBER(38),
	TYPE_COMPOSANT_ID NUMBER(38),
	COMPOSANT_ID NUMBER(38),
	C_STRUCTURE VARCHAR2(10),
	GRADE_UNIVERSITAIRE_ID NUMBER(38),
	ANNEE NUMBER(4),
	RECURSIF NUMBER DEFAULT 1,
    CONSTRAINT PK_GD_PERIMETRE_GIROFLE PRIMARY KEY (ID_GD_PERIMETRE_GIROFLE) USING INDEX TABLESPACE INDX_CKTL_SCOL,
    CONSTRAINT FK_GD_PERIMETRE_GIROFLE_ID FOREIGN KEY (ID_GD_PERIMETRE_GIROFLE) REFERENCES GRHUM.GD_PERIMETRE (ID_GD_PERIMETRE) DEFERRABLE INITIALLY DEFERRED,
    CONSTRAINT FK_GD_PERIMETRE_STRATEGIEID FOREIGN KEY (STRATEGIE_ID) REFERENCES SCO_SCOLARITE.GD_STRATEGIE_DEF_PERIMETRE (ID_GD_STRATEGIE_DEF_PERIMETRE) DEFERRABLE INITIALLY DEFERRED,
    CONSTRAINT FK_GD_PERIMETRE_TCOMPID FOREIGN KEY (TYPE_COMPOSANT_ID) REFERENCES SCO_SCOLARITE.TYPE_COMPOSANT (ID_TYPE_COMPOSANT) DEFERRABLE INITIALLY DEFERRED,
    CONSTRAINT FK_GD_PERIMETRE_COMPID FOREIGN KEY (COMPOSANT_ID) REFERENCES SCO_SCOLARITE.COMPOSANT (ID_COMPOSANT) DEFERRABLE INITIALLY DEFERRED,
    CONSTRAINT FK_GD_PERIMETRE_STRUCTURE FOREIGN KEY (C_STRUCTURE) REFERENCES GRHUM.STRUCTURE_ULR (C_STRUCTURE) DEFERRABLE INITIALLY DEFERRED,
    CONSTRAINT FK_GD_PERIMETRE_GRADE FOREIGN KEY (GRADE_UNIVERSITAIRE_ID) REFERENCES SCO_SCOLARITE.GRADE_UNIVERSITAIRE (ID_GRADE_UNIVERSITAIRE) DEFERRABLE INITIALLY DEFERRED
);
COMMENT ON TABLE SCO_SCOLARITE.GD_PERIMETRE_GIROFLE IS 'Table des périmètres de données pour les droits pour l''application Girofle';
COMMENT ON COLUMN SCO_SCOLARITE.GD_PERIMETRE_GIROFLE.STRATEGIE_ID IS 'Type de stratégie (lien vers la table GD_STRATEGIE_DEF_PERIMETRE)';
COMMENT ON COLUMN SCO_SCOLARITE.GD_PERIMETRE_GIROFLE.TYPE_COMPOSANT_ID IS 'Type de composant sur lequel on souhaite préciser un droit (lien vers la table TYPE_COMPOSANT)';
COMMENT ON COLUMN SCO_SCOLARITE.GD_PERIMETRE_GIROFLE.COMPOSANT_ID IS 'Composant sur lequel on précise un droit (lien vers la table COMPOSANT)';
COMMENT ON COLUMN SCO_SCOLARITE.GD_PERIMETRE_GIROFLE.C_STRUCTURE IS 'Structure sur lequel on précise un droit (lien vers la table GRHUM.STRUCTURE_ULR)';
COMMENT ON COLUMN SCO_SCOLARITE.GD_PERIMETRE_GIROFLE.GRADE_UNIVERSITAIRE_ID IS 'Grade universitaire sur lequel on précise un droit (lien vers la table GRADE_UNIVERSITAIRE)';
COMMENT ON COLUMN SCO_SCOLARITE.GD_PERIMETRE_GIROFLE.ANNEE IS 'Année de l''exercice';
COMMENT ON COLUMN SCO_SCOLARITE.GD_PERIMETRE_GIROFLE.RECURSIF IS 'Indique si le droit s''applique aux enfants du composant sélectionné';
